#include <stdio.h>

const int MAXN = 101;
const int MAXTIME = 10000;

int N;
int ncont[MAXN];
int cont[MAXN][MAXN], ctime[MAXN][MAXN];

int ReachAll(int start)
{
    int time[MAXN];
    int i, j;
    bool chg;

    for ( i = 1; i <= N; i++ ) time[i] = MAXTIME;
    time[start] = 0;

    do {
        chg = false;
        for ( i = 1; i <= N; i++ ) if ( time[i] < MAXTIME ) {
            for ( j = 0; j < ncont[i]; j++ ) {
                int c = cont[i][j];
                if ( time[c] > time[i] + ctime[i][j] ) {
                    time[c] = time[i] + ctime[i][j];
                    chg = true;
                }
            }
        }
    } while ( chg );

    int maxtime = 0;
    for ( i = 1; i <= N; i++ ) 
        if ( maxtime < time[i] ) maxtime = time[i];

    return maxtime;
}       

int main()
{
    while ( 1 ) {
        scanf(" %d", &N);
        if ( N == 0 ) break;

        int i, j;

        for ( i = 1; i <= N; i++ ) {
            scanf(" %d", &ncont[i]);
            for ( j = 0; j < ncont[i]; j++ ) 
                scanf(" %d %d", &cont[i][j], &ctime[i][j]);
        }

        int mini, mint;

        for ( i = 1; i <= N; i++ ) {
            int t = ReachAll(i);
            if ( i == 1 || t < mint ) {
                mini = i;
                mint = t;
            }
        }

        if ( mint >= MAXTIME ) printf("disjoint\n");
            else printf("%d %d\n", mini, mint);
    }

    return 0;
}
